
#include "lump_area.h"
#include <wx/listctrl.h>

class WadPanel : public wxPanel
{
private:
	Wad		wadfile;
	bool	opened_ok;

	vector<DWORD>		selection;
	wxListCtrl			*lump_list;
	LumpArea			*lump_area;
	wxStaticBoxSizer	*lump_area_sizer;

	wxColour	palette[256];
	string		palette_path;

public:
	enum
	{
		WP_LIST_LUMPS,
	};

	WadPanel(wxWindow *parent, string wadpath, bool zip = false);
	~WadPanel();

	bool	isOk() { return opened_ok; }
	string	getFilename();

	void	loadPalette();
	bool	closeWad();
	void	saveWad();
	void	saveWadAs();

	void	newLump();
	void	newLumpFromFile();
	void	deleteLump();
	void	renameLump();
	void	importLump();
	void	exportLump();
	void	exportImageLump(Lump* lump);
	void	exportLumpToWad();
	void	moveLump(bool up);

	void	addLumpToList(int index, Lump* lump);
	void	updateList(int index);
	void	updateList(Lump* lump);

	void	updateSelection();

	// Events
	void onLumpListChange(wxListEvent &event);
	void onLumpListEditName(wxListEvent &event);
	void onLumpListSelect(wxListEvent &event);
	void onLumpListDeSelect(wxListEvent &event);
	void onLumpListColResize(wxListEvent &event);

	DECLARE_EVENT_TABLE()
};

/*
class LumpTreeData : public wxTreeItemData
{
private:
	Lump*	lump;

public:
	LumpTreeData(Lump* lump) { this->lump = lump; }
	~LumpTreeData() {}

	Lump*	getLump() { return lump; }
	void	setLump(Lump* nlump) { lump = nlump; }
};
*/
